// Used MSP430 LCD Code, for a 16x2 character LCD display (Microtivity IM161 (also called 1602A) or equivalent),
// using the common HD44780 controller chip
// from   http://cacheattack.blogspot.com/2011/06/quick-overview-on-interfacing-msp430.html

//#include <msp430.h>
//#include "msp430g2553.h"
//#include <tiva.h>

//******NOTE****************************
//Comments marked //o are old code from original LCD
//

#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "inc/hw_memmap.h"
#include "inc/tm4c123gh6pm.h"
#include "driverlib/gpio.h"
#include "driverlib/pin_map.h"
#include "driverlib/sysctl.h"
#include "buttons.h"


//Defines from 212

#include <stdbool.h>
#include <stdint.h>
#include <math.h>
#include "inc/hw_memmap.h"
#include "driverlib/adc.h"
#include "driverlib/gpio.h"
#include "driverlib/pin_map.h"
#include "driverlib/sysctl.h"
#include "driverlib/uart.h"
#include "uartstdio.h"
#include "inc/tm4c123gh6pm.h"
#define M_E     2.7182818284590452354
#define PI2 6.2383185307

volatile int avg[125];
volatile int avgCount = 0;
volatile float average = 0;
uint32_t pui32ADC0Value[4];
float values[256];
volatile int good = 0;
float ref[1024];
short svalues[1024];
//int imag[N_WAVE];
short imag[1024];

volatile int count = 0;
void movingAverage(void);

volatile int firstHighest;
volatile int secondHighest;
volatile bool increase = false;
volatile bool firstFound = false;
volatile float frequency = 0;
volatile int periodCount = 0;
volatile float avgSampleSize = 0;
volatile bool zeroMet = false;
volatile int distance = 0;

//enumeration for lcd button acd
enum button
{
    right, up, down, left, select, none
};

void highE(void);

void fourier(void);

void LCDButtons(void);
volatile int buttonVal[1];
//End defines from 212





#define FALSE 0
#define TRUE 1
#define LCM_DIR P2DIR
#define LCM_OUT P2OUT

// Define symbolic LCM - MCU pin mappings.

#define LCM_PIN_RS BIT0 // P2.0
#define LCM_PIN_EN BIT1 // P2.1
#define LCM_PIN_D7 BIT5 // P2.5
#define LCM_PIN_D6 BIT4 // P2.4
#define LCM_PIN_D5 BIT3 // P2.3
#define LCM_PIN_D4 BIT2 // P2.2
#define LCM_PIN_MASK ((LCM_PIN_RS | LCM_PIN_EN | LCM_PIN_D7 | LCM_PIN_D6 | LCM_PIN_D5 | LCM_PIN_D4))

#define LEDR BIT0
#define LEDG BIT6
#define TXD  BIT2
#define RXD  BIT1
#define IN4 BIT5 //These bits are toggled to switch motor direction
#define IN3 BIT4 //
#define LED_OUT P1OUT
#define LED_DIR P1DIR
#define Button1 0x08

#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

//void MainLoop(long looper);      //delay
volatile unsigned int LCDstateMaster = 0;
volatile char LCDstate=0;
volatile char state = 0;
//For ADC
//#define BUFFERLENGTH 128

//float avgVoltage = 0;
//volatile int currentWriteIndex = 0;
//volatile unsigned char newADCdataIsAvailable = 0;
//volatile unsigned int buffer[BUFFERLENGTH];

//char string[] = { "Demo" }; //the print out
//volatile unsigned int i = 0; //Counter


                             //Putty Code
                             //<PuTTY>
//#pragma vector=USCIAB0TX_VECTOR
//__interrupt void USCI0TX_ISR(void)
//{
//    UCA0TXBUF = string[i++]; // TX next character
//    if (i == sizeof string - 1) // TX over?
//    {
//        i = 0;
//        UC0IE &= ~UCA0TXIE; // Disable USCI_A0 TX interrupt
//    }
//}

//#pragma vector=USCIAB0RX_VECTOR
//__interrupt void USCI0RX_ISR(void)
//{
//    LPM0_EXIT;
//}
//End Putty Code
//</PuTTY>


//ADC Code
//<ADC>
//#pragma vector=ADC10_VECTOR
//__interrupt void ADC10_ISR(void)
//{
//    P1OUT ^= LEDR;
//    newADCdataIsAvailable = 1;
//    buffer[currentWriteIndex] = ADC10MEM; // copy new data into buffer
//    currentWriteIndex = (currentWriteIndex + 1) & (BUFFERLENGTH - 1);
//    ADC10CTL0 |= ADC10SC; // start next conversion... or, timer-driven?
//}
//#pragma vector=TIMER0_A0_VECTOR
//__interrupt void Timer_ISR(void)
//{
//    LPM0_EXIT;/
//}
//End ADC Code
//</ADC>
int freq2 = 441;
volatile bool motorDirection = 1;
void onButtonDown(void);
//void onButtonUp(void);
void ClearLcmScreen();
void InitializeLcm(void);
void PrintStr(char *Text);
void SendByte(char ByteToSend, int IsData);

/*void onButtonUp(void) {
    if (GPIOIntStatus(GPIO_PORTF_BASE, false) & GPIO_PIN_4) {
        // PF4 was interrupt cause
        printf("Button Up\n");
        GPIOIntRegister(GPIO_PORTF_BASE, onButtonDown); // Register our handler function for port F
        GPIOIntTypeSet(GPIO_PORTF_BASE, GPIO_PIN_4,
            GPIO_FALLING_EDGE);         // Configure PF4 for falling edge trigger
        GPIOIntClear(GPIO_PORTF_BASE, GPIO_PIN_4);  // Clear interrupt flag
    }
}*/


void main(void)
{



    SysCtlClockSet(
    SYSCTL_SYSDIV_16 | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN | SYSCTL_XTAL_1MHZ);

    //o    SysCtlClockSet(SYSCTL_SYSDIV_2_5| SYSCTL_USE_PLL | SYSCTL_OSC_INT | SYSCTL_XTAL_16MHZ);

    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA); //lcd
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB); //motor
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF); //buttons and led
    while (!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOF))
    {
    }

//    P1SEL |= RXD + TXD; // P1.1 = RXD, P1.2=TXD
//    P1SEL2 |= RXD + TXD; // P1.1 = RXD, P1.2=TXD
    //GPIODirModeSet(GPIO_PORTF_BASE, GPIO_PIN_4, GPIO_DIR_MODE_OUT)
//o    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA); //lcd
//o    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF); //buttons and led
//o    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB); //motor
    //    P2DIR |= 0xFF; // All P2.x outputs
    GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5);
    //    P2OUT &= 0x00; // All P2.x reset
    GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x000000);

    //<212>
    //already defined below-> GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_6);
    GPIOPinTypeADC(GPIO_PORTE_BASE, GPIO_PIN_2);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC1);

    //ADC setup
     SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
     SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC1);

     ADCSequenceConfigure(ADC0_BASE, 0, ADC_TRIGGER_PROCESSOR, 0);
     ADCSequenceConfigure(ADC1_BASE, 0, ADC_TRIGGER_PROCESSOR, 0);

     ADCSequenceStepConfigure(ADC0_BASE, 0, 3,
     ADC_CTL_IE | ADC_CTL_END | ADC_CTL_CH0);
     ADCSequenceStepConfigure(ADC1_BASE, 0, 3,
     ADC_CTL_IE | ADC_CTL_END | ADC_CTL_CH1);

     ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE |
     ADC_CTL_END);
     ADCSequenceStepConfigure(ADC1_BASE, 3, 0, ADC_CTL_CH1 | ADC_CTL_IE |
     ADC_CTL_END);

     ADCSequenceEnable(ADC0_BASE, 3);
     ADCSequenceEnable(ADC1_BASE, 3);

     ADCIntClear(ADC0_BASE, 3);
     ADCIntClear(ADC1_BASE, 3);

    //</212>



    //P1REN |= Button1;             // enable pull-up resistor for switch
    //P1OUT |= Button1;             // enable pull-up resistor for S2 (P1.3)
   // P1IE  |= Button1;             // P1.3 interrupt enabled
   // P1IFG &= ~Button1;            // enable ALL interrupts (sets GIE bit high in SR)

    // Pin F4 setup
   //    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);        // Enable port F
  //     GPIOPinTypeGPIOInput(GPIO_PORTF_BASE, GPIO_PIN_4);  // Init PF4 as input
  //     GPIOPadConfigSet(GPIO_PORTF_BASE, GPIO_PIN_4,
  //         GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD_WPU);  // Enable weak pullup resistor for PF4
       ButtonsInit();
       // Interrupt setup
       GPIOIntDisable(GPIO_PORTF_BASE, GPIO_PIN_0);        // Disable interrupt for PF4 (in case it was enabled)
       GPIOIntClear(GPIO_PORTF_BASE, GPIO_PIN_0);      // Clear pending interrupts for PF4
       GPIOIntRegister(GPIO_PORTF_BASE, onButtonDown);     // Register our handler function for port F
       GPIOIntTypeSet(GPIO_PORTF_BASE, GPIO_PIN_0,
           GPIO_FALLING_EDGE);             // Configure PF4 for falling edge trigger
       GPIOIntEnable(GPIO_PORTF_BASE, GPIO_PIN_0);     // Enable interrupt for PF4

       //IntMasterEnable();

    //P1DIR |= LEDR + LEDG + IN4 + IN3;
    GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_1 | GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_6 | GPIO_PIN_7 );
    //P1OUT &= ~(IN4 + IN3);            // Set the motor off
    //P1OUT &= ~(LEDR + LEDG);
    GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 | GPIO_PIN_3 , 0x0000);
    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 | GPIO_PIN_1 , 0x0000);
//    P1OUT &= 0x00;
//    UCA0CTL1 |= UCSSEL_2; // SMCLK
//    UCA0BR0 = 104;                            // 1MHz 9600
//    UCA0BR1 = 0;                              // 1MHz 9600
//    UCA0MCTL = UCBRS2 + UCBRS0; // Modulation UCBRSx = 5
//    UCA0CTL1 &= ~UCSWRST; // **Initialize USCI LCDstate machine**
//    UC0IE |= UCA0RXIE; // Enable USCI_A0 RX interrupt


    //TA1CCR0 = 300000;              // Set the TimerA0 debounce delay
    //TA1CCTL0 = CCIE;              // enable the interrupts from TimerA0 CC0
    //TA1CTL = TASSEL_2 + MC_0;     // Set the timer A to SMCLCK, Off_Mode

    //LCD
    InitializeLcm();
    ClearLcmScreen();
//    char string[] = "Demo";
//    PrintStr("Motor Demo");
    PrintStr("LCD Demo");
//    UC0IE |= UCA0RXIE; // Enable USCI_A0 RX interrupt

    //__bis_SR_register(GIE);
//    __enable_interrupt();

 //   int count;

    //BCSCTL3 |= LFXT1S_2;
    //BCSCTL1 |= DIVA_2; // divide ACLK by 4

//    ADC10CTL1 = CONSEQ_0 | INCH_4 | ADC10DIV_7 | ADC10SSEL_3; // use SMCLK
//    ADC10CTL0 = SREF_0 | ADC10SHT_3 | ADC10ON | ADC10IE;

//    while (ADC10CTL1 & BUSY);

 //   ADC10CTL0 |= ENC + ADC10SC;
//    _enable_interrupt();
//    int temp = 0;
//    char temp1 = 0;
//    char temp2 = 0;
//    char temp3 = 0;
//    char temp4 = 0;


    while (1)// loop forever

    {
        readButton();
/*
              switch(LCDstate)
              {
              case 0:

                  break;
              case 1:
                  //P1OUT |= IN4;
                  //P1OUT |= LEDG;
                  //GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 | GPIO_PIN_3 , 0x0000);
                  //GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0 | GPIO_PIN_1 , 0x0000);
                  GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_3 , GPIO_PIN_3);
                  GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_7 , GPIO_PIN_7);
                  LCDstate = 0;
                  break;
              case 2:
                  //P1OUT &= ~IN4;
                  //P1OUT &= ~LEDG;
                  GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_3 , 0x0000);
                  GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_7 , 0x0000);
                  //GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 | GPIO_PIN_3 , 0x0000);
                  //GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0 | GPIO_PIN_1 , 0x0000);
                  //P1OUT |= IN3;
                  //P1OUT |= LEDR;
                  GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 , GPIO_PIN_1);
                  GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6 , GPIO_PIN_6);
                  LCDstate = 0;
                  break;
              case 3:
                  //P1OUT &= ~(IN4 + IN3 +LEDR + LEDG);//set the motor off
                  GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 | GPIO_PIN_3 , 0x0000);
                  GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6 | GPIO_PIN_7 , 0x00000000);
                  LCDstate = 0;
                  break;
              default:
                  break;
              }
*/
        /*
  //Under construction

        //buttons:

        //if (input resetbutton == 0)
        //  reset == 1;

              switch(state)
              {
              case 0:
                  if (button != 5)
                  {
                      state = 1;
                      LCDstateMaster = 2;
                  }
                  break;
              case 1://select tuning
                  //toggles between frequency and note
                      if (button == 1 || button == 2)
                      {
                          LCDstateMaster = LCDsateMaster%1 +2;
                          LCDstate = LCDstateMaster;
                      }
                      if (button == 0 || button == 4 )
                      {
                          if (LCDstateMaster == 2;//cursor is on note
                          {
                              state = 2;
                              LCDstateMaster = 4;
                          }
                          else //cursor is on frequency
                          {
                              state = 3;
                              LCDstateMaster = 5;
                          }
                      }
                  break;
              case 2: //select note
                  if (button == 1)
                  {
                      noteSelected++;
                      LCDstate = LCDstateMaster;
                  }
                  if (button == 2)
                  {
                      noteSelected--;
                      LCDstate = LCDstateMaster;
                  }
                  if (button == 0 || button == 4 )
                  {
                      freqRef = notes[noteSelected];//referencing an array of stored note values
                      oldstate = state;
                      state = 4;
                      oldLCDstate = LCDstateMaster;
                      LCDstateMaster = 6;
                      LCDstate = LCDstateMaster;
                  }
                  if (button == 3)
                  {
                      state = 1;
                      LCDstateMaster = 2;
                      LCDstate = LCDstateMaster;
                  }
                  break;
              case 3:
                  if (button == 1)
                  {
                      frequencySelected++;
                      LCDstate = LCDstateMaster;
                  }
                  if (button == 2)
                  {
                      frequencySelected--;
                      LCDstate = LCDstateMaster;
                  }
                  if (button == 0 || button == 4 )
                  {
                      freqRef = frequencySelected;
                      oldstate = state;
                      state = 4;
                      oldLCDstate = LCDstateMaster;
                      LCDstateMaster = 6;
                      LCDstate = LCDstateMaster;
                  }
                  if (button == 3)
                  {
                      state = 1;
                      LCDstateMaster = 3;
                      LCDstate = LCDstateMaster;
                  }
                  break;
              case 4:
                  Tune(freqRef);
                  LCDstateMaster = 7;
                  if (reset)
                  {
                      state = oldstate;
                      LCDstateMaster = oldLCDstate;
                  }
                  break;
              default:
                  break;
              }
*/
              int freq = 440;
              char string[] = "____Hz";
              char c1 = freq % 10 + '0';
              char c2 = (freq / 10) % 10 + '0';
              char c3 = (freq / 100) % 10 + '0';
              char c4 =  (freq / 1000) % 10 + '0';
              string[0] = c4;
              string[1] = c3;
              string[2] = c2;
              string[3] = c1;

              freq2 = 441;
              char string2[] = "____Hz";
              char d1 = freq2 % 10 + '0';
              char d2 = (freq2 / 10) % 10 + '0';
              char d3 = (freq2 / 100) % 10 + '0';
              char d4 = (freq2 / 1000) % 10 + '0';
              string2[0] = d4;
              string2[1] = d3;
              string2[2] = d2;
              string2[3] = d1;
              switch(LCDstate)
              {
              case 0:
                  //ClearLcmScreen();
                  //PrintStr("LCD Demo");
                  //__delay_cycles();
                  //LCDstate = 0;
                  break;
              case 1:
                  ClearLcmScreen();
                  //P1OUT |= LEDG;
                  //LcmSetCursorPosition(1, 1);
                  PrintStr("Select Tuning");
                  LcmSetCursorPosition(1, 0);
                  PrintStr("Mode");
                  LCDstate = 0;
                  break;
              case 2:
                  ClearLcmScreen();
                  //P1OUT &= ~LEDG;
                  PrintStr("@ Note");
                  LcmSetCursorPosition(1, 0);
                  PrintStr("  Frequency");
                  LCDstate = 0;
                  break;
              case 3:
                  ClearLcmScreen();
                  PrintStr("  Note");
                  LcmSetCursorPosition(1, 0);
                  PrintStr("@ Frequency");
                  LCDstate = 0;
                  break;
              case 4:
                  ClearLcmScreen();
                  //P1OUT &= ~LEDG;
                  PrintStr("E4");
                  //LcmSetCursorPosition(1, 0);
                  //PrintStr("  Frequency");
                  LCDstate = 0;
                  break;
              case 5:
                  ClearLcmScreen();
                  PrintStr(string);
                  //LcmSetCursorPosition(1, 0);
                  //PrintStr("@ Frequency");
                  LCDstate = 0;
                  break;
              case 6:
                  ClearLcmScreen();
                  PrintStr("Press Stop to");
                  LcmSetCursorPosition(1, 0);
                  PrintStr("Quit Tuning");
                  SysCtlDelay(80000000);
                  LCDstate = 7;
                  break;
              case 7:
                  ClearLcmScreen();
                  PrintStr("Tuning");
                  LcmSetCursorPosition(1, 0);
                  PrintStr(string2);
                  LCDstate = 0;
                  break;
              default:
                  LCDstate = 0;
                  break;
              }

//        P1OUT ^= TEST;
//        if (newADCdataIsAvailable)
//        {
//            P1OUT |= LEDG;
//            newADCdataIsAvailable = 0; // reset flag
//
//            for (count = 0; count < BUFFERLENGTH; count++)
//            {
///                avgVoltage += buffer[count];
//            }
//            avgVoltage = avgVoltage / BUFFERLENGTH;
//            P1OUT ^= TEST;
//            avgVoltage = avgVoltage / .436;
//            P1OUT &= ~LEDG;
//        }
//        P1OUT ^= TEST;
//        temp = avgVoltage;
//        temp1 = temp % 10 + '0';
 //       temp2 = (temp / 10) % 10 + '0';
 //       temp3 = (temp / 100) % 10 + '0';
//        temp4 = (temp / 1000) % 10 + '0';

        //Print to PuTTY
//        string[0] = temp4;
//        string[1] = temp3;
//        string[2] = '.';
//        string[3] = temp2;
//        string[4] = temp1;
//        string[5] = '\r';
//        string[6] = '\n';
//        string[7] = '\0';
//        P1OUT ^= TEST;
//        UC0IE |= UCA0TXIE; // Enable USCI_A0 TX interrupt
//        while (UC0IE != (UC0IE & ~UCA0TXIE)) //Do nothing until done sending
//        {
//        }
//        P1OUT ^= TEST;

        //Print to LCD
//        string[5] = ' ';
//        string[6] = ' ';
//        ClearLcmScreen();
//       PrintStr(string);
//        P1OUT ^= TEST;
        // set timer to go to sleep for a while in LPM,
        // then wake and run through event loop again
//        TACCTL0 = CCIE;
//        TACCR0 = 0x00FF;
//        TACTL = TASSEL_1 | MC_2 | TACLR;
//        LPM0;
//        volatile unsigned int i;
//        for(i=0;i<10000;i++);

    }
}

//Button functions
//void MainLoop(long looper)
//{
//    volatile unsigned int MainLoopCounter;
    //detect button press to switch LCDstates
//    for (MainLoopCounter = 0; MainLoopCounter < looper; ++MainLoopCounter);
//}
/*
#pragma vector=TIMER1_A0_VECTOR
__interrupt void Timer_A1 (void) // Timer A1 interrupt service routine
{
    if(!(Button1 & P1IN))
    {
            direction = (direction+1)%4;
            LCDstate = direction;
            TA1CTL &= ~(MC_3);
            //P1OUT ^= IN4;
    }
}
//button press interrupt
#pragma vector=PORT1_VECTOR
__interrupt void Port_1( void )
{
    if(!(TA1CTL & MC_0))
    {
        TA1CTL |= MC_1;
    }
    P1IFG &= ~Button1; // P1.3 IFG clear
}*/

//LCD Functions
//<LCD>

// This is the function that must be called
// whenever the LCM needs to be told to
// scan its data bus. Assumes 1 MHz clock...
void PulseLcm()
{
    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, 0x0);
    //LCM_OUT &= ~LCM_PIN_EN; // pull EN bit low
    SysCtlDelay(16000);
   // __delay_cycles(200); // delay 0.2 ms

    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, GPIO_PIN_1);
    //LCM_OUT |= LCM_PIN_EN; // pull EN bit high
    //__delay_cycles(200);
    SysCtlDelay(16000);
    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, 0x0);
    //LCM_OUT &= (~LCM_PIN_EN); // pull EN bit low again
    SysCtlDelay(16000);
}

// Send a byte on the data bus in the 4 bit mode
// This requires sending the data in two chunks.
// The high nibble first and then the low nibble
void SendByte(char ByteToSend, int IsData)
{
    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 | GPIO_PIN_1 , 0x00);
    GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x000000);
    //GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2, 0x0);
    //GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_3, 0x0);
    //GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_4, 0x0);
    //GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_5, 0x0);
    //LCM_OUT &= (~LCM_PIN_MASK); // clear all pins

                                // set High Nibble (HN) -
                                // usefulness of the identity mapping
                                // apparent here. We can set the
                                // DB7 - DB4 just by setting P1.7 - P1.4
                                // using a simple assignment

    GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, ((ByteToSend & 0xF0) >> 2));
    //LCM_OUT |= ((ByteToSend & 0xF0) >> 2);

    if (IsData == TRUE) // sending data
    {
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 , 0x01);
        //LCM_OUT |= LCM_PIN_RS;
    }
    else // sending command rather than data
    {
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 , 0x00);
        //LCM_OUT &= ~LCM_PIN_RS;
    }

    PulseLcm(); // voltages are set; tell LCM to read them

                // set Low Nibble (LN) -
    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 | GPIO_PIN_1 , 0x00);
    GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x000000);
    //LCM_OUT &= (~LCM_PIN_MASK);
    GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, ((ByteToSend & 0x0F) << 2));
    //LCM_OUT |= ((ByteToSend & 0x0F) << 2);

    if (IsData == TRUE)
    {
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 , 0x01);
        //LCM_OUT |= LCM_PIN_RS;
    }
    else
    {
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 , 0x00);
        //LCM_OUT &= ~LCM_PIN_RS;
    }

    PulseLcm(); // voltages are set; tell LCM to read them
}

// Set the position of the cursor on the screen
// Parameters:
//   Row - zero based row number
//   Col - zero based col number
// Returns:   void
void LcmSetCursorPosition(char Row, char Col)
{
    char address;

    // construct address from (Row, Col) pair
    if (Row == 0)
    {
        address = 0;
    }
    else
    {
        address = 0x40;
    }

    address |= Col;
    SendByte(0x80 | address, FALSE);
}

// Clear the screen data and return the
// cursor to home position
// Parameters: void
// Returns:  void
void ClearLcmScreen()
{
    SendByte(0x01, FALSE);
    SendByte(0x02, FALSE);
}

// Print a string of characters to the screen
// Parameters:  Text - null terminated string of chars
// Returns: void
void PrintStr(char *Text)
{
    char *c;
    c = Text;

    while ((c != 0) && (*c != 0))
    {
        SendByte(*c, TRUE);
        c++;
    }
}
// Initialize the LCM after power-up.
// Note: This routine must not be called twice on the
// LCM. This is not so uncommon when the power
// for the MCU and LCM are separate.
// Parameters: void
// Returns:  void
void InitializeLcm(void)
{
    // set the MSP pin configurations
    // and bring them to low
    //GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5);
    //    P2OUT &= 0x00; // All P2.x reset
    //GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x000000);

    //LCM_DIR |= LCM_PIN_MASK;
    //LCM_OUT &= ~(LCM_PIN_MASK);

    // wait 100ms for the LCM to warm up and reach
    // active regions. Remember MSPs can power
    // up much faster than the LCM. (Assumes 1 MHz clock...)
    SysCtlDelay(1000000);
    //__delay_cycles(500000);

    // initialize the LCM module
    //
    // 1. Set 4-bit input

    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_0 , 0x00);
    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1 , 0x00);
    //LCM_OUT &= ~LCM_PIN_RS;
    //LCM_OUT &= ~LCM_PIN_EN;
    GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_3 , GPIO_PIN_3);
    //LCM_OUT = 0x08;
    PulseLcm();

    // set 4-bit input - second time.
    // (as reqd by the spec.)
    SendByte(0x28, FALSE);

    // 2. Display on, cursor on, blink cursor
    SendByte(0x0E, FALSE);

    // 3. Cursor move auto-increment
    SendByte(0x06, FALSE);
}

//End of LCD Functions
//</LCD>

void onButtonDown(void) {
    if (GPIOIntStatus(GPIO_PORTF_BASE, false) & GPIO_PIN_0) {
        // PF4 was interrupt cause
        //printf("Button Down\n");
        //GPIOIntRegister(GPIO_PORTF_BASE, onButtonUp);   // Register our handler function for port F
        LCDstateMaster = (LCDstateMaster+1)%8;
        LCDstate = LCDstateMaster;
        //GPIOIntTypeSet(GPIO_PORTF_BASE, GPIO_PIN_4,
        //    GPIO_RISING_EDGE);          // Configure PF4 for rising edge trigger
        GPIOIntClear(GPIO_PORTF_BASE, GPIO_PIN_0);  // Clear interrupt flag
    }
}

void toggleMotor()
{
    if (motorDirection==1)
    {
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 , 0x0000);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6 , 0x0000);
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_3 , GPIO_PIN_3);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_7 , GPIO_PIN_7);
        motorDirection =0 ;
    }
    else
    {
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_3 , 0x0000);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_7 , 0x0000);
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1 , GPIO_PIN_1);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6 , GPIO_PIN_6);
        motorDirection = 1;
    }
}
//*********************************************************************
//Functions from 212

//sample
void Tune(freqRef)
{

    int freqChange=10;
    int freqDetect=10;
    int freqChangePrevious=10;
    while (count < 256)
    {

        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_3, 0x0);

        //
        // Trigger the ADC conversion.
        //
        ADCProcessorTrigger(ADC0_BASE, 3);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, GPIO_PIN_6);
        //
        // Wait for conversion to be completed.
        //
        while (!ADCIntStatus(ADC0_BASE, 3, false))
        {
        }
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, 0x0);

        //
        // Clear the ADC interrupt flag.
        //
        ADCIntClear(ADC0_BASE, 3);

        //
        // Read ADC Value.
        //
        ADCSequenceDataGet(ADC0_BASE, 3, pui32ADC0Value);
        values[count] = pui32ADC0Value[0];

        count++;
      SysCtlDelay(980);

    }

    movingAverage();


    freqDetect = 441;


    freq2 = freqDetect; //sends this number to the "Tuning" display
    //need a returned heard frequency
    freqChange = freqRef-freqDetect;
    if (abs(freqChange)>freqChangePrevious)
    {
        toggleMotor();
    }
    freqChangePrevious=freqChange;

}


void fourier ()
{
int i;
for (i = 0;i< 256;i++)
{
values[i] = values[i];

}
int z;
for (z = 0;z< 256;z++)
{
ref[z] = sqrt(values[z] * (pow(M_E,(PI2 *-330/z ))));

}

for (z = 0;z< 256;z++)
 {
    if (z%18 == 0)
    {
 ref[z] = ref[z];
    }
    else
    {
      //  ref[z] = 0;
    }

 }
}



void highE(void)
{
   volatile int samp = 0;
   int z;
   for (z = 0; z < 256; z++)
   {
       values[z] = values[z] *cos(330*z)*cos(330*z);


}
}

void movingAverage(void)
{
   count = 0;
   int plus = 0;
   int minus = 0;
   int z;
   for (z = 0; z < 256; z++)
   { values[z] = values[z] *cos(330*z);
       //values[z]=values[z]-900;
      // values[z] = values[z] - 1700;
       if (values[z] < 0)
       {
          values[z] = 0;

       }

       if (z>0 && values[z-1] != 0)
               {
                values[z] = 0;

               }
   }

   fourier();
/*
   int i;
   for (i = 0; i < 256; i++)
   {
       if ((i > 1) && (values[i] > values[i - 1]))
       {
           increase = true;
       }

       if (values[i] == 0)
       {
           zeroMet = true;
       }

       if ((increase == true) && (values[i] < values[i - 2])
               && (firstFound == false) && (zeroMet == true))
       {
           zeroMet = false;
           increase = false;
           firstFound = true;
           firstHighest = i - 1;

           // check high E

       }

       if ((increase == true) && (values[i] < values[i - 1])
               && (firstFound == true) && (zeroMet == true))
       {
           zeroMet = false;
           increase = false;

           firstFound = false;

           secondHighest = i - 2;

           if ((secondHighest - firstHighest) < 0)
           {

               avgSampleSize = avgSampleSize + (firstHighest - secondHighest);
           }

           else
           {
               avgSampleSize = avgSampleSize + (secondHighest - firstHighest);
           }

           periodCount++;
       }
   }
   avgSampleSize = avgSampleSize / periodCount;

   frequency = 5861.6647 / (avgSampleSize);*/
}

enum button readButton()
{
    while(1){
    // GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_3, 0x0);

     //
     // Trigger the ADC conversion.
     //
     ADCProcessorTrigger(ADC1_BASE, 3);
     //GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, GPIO_PIN_6);
     //
     // Wait for conversion to be completed.
     //
     while (!ADCIntStatus(ADC1_BASE, 3, false))
     {
     }
     // GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, 0x0);
     //
     // Clear the ADC interrupt flag.
     //
     ADCIntClear(ADC1_BASE, 3);

     //
     // Read ADC Value.
     //
     ADCSequenceDataGet(ADC1_BASE, 3, pui32ADC0Value);
     buttonVal[0] = pui32ADC0Value[0];
    }
    return none;
     // count++;

//***********************
//Needs ranges for values

}

